#!/bin/sh
#format: mtdpart number, ubi device number, volume name, mount dir
mtdtab_config="4 0 config /overlay_etc"
mtdtab_log="5 1 log /usr/var"
mtdtab_binary="6 2 binary /usr/local"
mtdtab_temp="7 3 temp /usr/tmp"
mtdtab_fw1="2 13 fw1 /firmware_dir"
mtdtab_fw2="3 13 fw2 /firmware_dir"

mtdtab_trymount() {
    mtdno=$1
    ubino=$2
    volnm=$3
    mntdir=$4
    ubiattach -m $mtdno -d $ubino /dev/ubi_ctrl
    mkdir -p $mntdir
    mopts="sync,noatime"
    [ "$volnm" = "temp" ] && mopts="noatime"
    [ "$volnm" = "log" ] && mopts="noatime"
    mcmd="mount -t ubifs -o $mopts ubi${ubino}:nand_${volnm} $mntdir"
    if ! eval $mcmd; then
        ubiupdatevol  /dev/ubi${ubino}_0 -t
        eval $mcmd
    fi
    if [ "$volnm" = "log" ];  then
        logmnt=$(cat /proc/mounts |grep nand_log|cut -d ' ' -f4 )
        #handle the case the log parition is so broken mounted as readonly
        if echo $logmnt | grep -q "ro"; then
          umount $mntdir
          ubiupdatevol  /dev/ubi${ubino}_0 -t
          eval $mcmd
        fi
    fi
}

mtdtab_mntdir() {
  echo $4
}

mtdtab_mtdno() {
  echo $1
}

mtdtab_ubino() {
  echo $2
}

mtdtab_volnm() {
  echo $3
}
